<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/events/KeyboardEvent.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_c33611b4dec78f96017d2ccf425d656a.html">events</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">KeyboardEvent.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="KeyboardEvent_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &lt;SFML/Graphics.hpp&gt;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &lt;<a class="code" href="Event_8hpp.html">core/Event.hpp</a>&gt;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &lt;sstream&gt;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span> </div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span>{</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span> </div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html">   10</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1KeyboardEvent.html">KeyboardEvent</a> : <span class="keyword">public</span> <a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>{</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#a2dd18280ee3e99347875156d4aa8a600">   13</a></span>    <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#a2dd18280ee3e99347875156d4aa8a600">KeyboardEvent</a>();</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#acbc54be23fd27c01ab5f6ce6c558f85d">   14</a></span>    <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#acbc54be23fd27c01ab5f6ce6c558f85d">~KeyboardEvent</a>() <span class="keyword">override</span> = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#a95443182d3146abfb2549ee1d9bdd72c">   16</a></span>    [[nodiscard]] <span class="keyword">inline</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#a95443182d3146abfb2549ee1d9bdd72c">GetEventType</a>() const -&gt; <a class="code hl_enumeration" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> override = 0;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#abc64d61158c025aa2e940ddaecf04876">   18</a></span>    auto <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#abc64d61158c025aa2e940ddaecf04876">GetKeycode</a>() -&gt; sf::Keyboard::Key;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#a0a50fcf8c135a015551d375b4865f71c">   19</a></span>    auto <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#a0a50fcf8c135a015551d375b4865f71c">KeycodeToString</a>() -&gt; <span class="keywordtype">char</span>;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#a81e1418e6e8554e9cedf580bd7b2b5ac">   20</a></span>    virtual auto <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#a81e1418e6e8554e9cedf580bd7b2b5ac">to_string</a>() -&gt; <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> = 0;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>  protected:</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>    <span class="comment">// properly detects A-Z; if some other key is pressed becomes &#39;~&#39; to</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    <span class="comment">// indicate that</span></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#a5963a3b82f5bd8c2fca8156297f15725">   25</a></span>    <span class="keywordtype">char</span> <a class="code hl_variable" href="classgg_1_1KeyboardEvent.html#a5963a3b82f5bd8c2fca8156297f15725">mKeycodeString</a>;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1KeyboardEvent.html#ada0379b2c75fed648eada3923788b035">   26</a></span>    sf::Keyboard::Key <a class="code hl_variable" href="classgg_1_1KeyboardEvent.html#ada0379b2c75fed648eada3923788b035">mKeycode</a>;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>};</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="classgg_1_1KeyPressedEvent.html">   29</a></span>class <a class="code hl_class" href="classgg_1_1KeyPressedEvent.html">KeyPressedEvent</a> : public <a class="code hl_class" href="classgg_1_1KeyboardEvent.html">KeyboardEvent</a></div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>{</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="classgg_1_1KeyPressedEvent.html#a158a2d0cf96a6a404aaf7c8bec89acaa">   32</a></span>    <a class="code hl_function" href="classgg_1_1KeyPressedEvent.html#a158a2d0cf96a6a404aaf7c8bec89acaa">KeyPressedEvent</a>(sf::Keyboard::Key);</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="classgg_1_1KeyPressedEvent.html#a466c97780ec2cb0c9fbed923060e4ac2">   33</a></span>    <a class="code hl_function" href="classgg_1_1KeyPressedEvent.html#a466c97780ec2cb0c9fbed923060e4ac2">~KeyPressedEvent</a>() <span class="keyword">override</span> = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="classgg_1_1KeyPressedEvent.html#a59ebd4dc540d6cee0715652c0c09e868">   35</a></span>    [[nodiscard]] <span class="keyword">inline</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1KeyPressedEvent.html#a59ebd4dc540d6cee0715652c0c09e868">GetEventType</a>() const -&gt; <a class="code hl_enumeration" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> override;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="classgg_1_1KeyPressedEvent.html#a233ffc8ff8db46a79d5797183c6650ca">   37</a></span>    auto <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#a81e1418e6e8554e9cedf580bd7b2b5ac">to_string</a>() -&gt; <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> override;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>  private:</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>};</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span> </div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="classgg_1_1KeyReleasedEvent.html">   42</a></span>class <a class="code hl_class" href="classgg_1_1KeyReleasedEvent.html">KeyReleasedEvent</a> : public <a class="code hl_class" href="classgg_1_1KeyboardEvent.html">KeyboardEvent</a></div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>{</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="classgg_1_1KeyReleasedEvent.html#a1f482b17b96ceb5141a4b4cfbbe4a154">   45</a></span>    <a class="code hl_function" href="classgg_1_1KeyReleasedEvent.html#a1f482b17b96ceb5141a4b4cfbbe4a154">KeyReleasedEvent</a>(sf::Keyboard::Key keycode);</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="classgg_1_1KeyReleasedEvent.html#ad26aca2fd0b1a7ec81ffec12bd886479">   46</a></span>    <a class="code hl_function" href="classgg_1_1KeyReleasedEvent.html#ad26aca2fd0b1a7ec81ffec12bd886479">~KeyReleasedEvent</a>() <span class="keyword">override</span> = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> </div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="classgg_1_1KeyReleasedEvent.html#a49587642a655c28b0c2d4042c0836e50">   48</a></span>    [[nodiscard]] <span class="keyword">inline</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1KeyReleasedEvent.html#a49587642a655c28b0c2d4042c0836e50">GetEventType</a>() const -&gt; <a class="code hl_enumeration" href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">EventType</a> override;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span> </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="classgg_1_1KeyReleasedEvent.html#a95c1d915380747f69026b8cb59058763">   50</a></span>    auto <a class="code hl_function" href="classgg_1_1KeyboardEvent.html#a81e1418e6e8554e9cedf580bd7b2b5ac">to_string</a>() -&gt; <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> override;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>  private:</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>};</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aEvent_8hpp_html"><div class="ttname"><a href="Event_8hpp.html">Event.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1IEvent_html"><div class="ttname"><a href="classgg_1_1IEvent.html">gg::IEvent</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:41</div></div>
<div class="ttc" id="aclassgg_1_1KeyPressedEvent_html"><div class="ttname"><a href="classgg_1_1KeyPressedEvent.html">gg::KeyPressedEvent</a></div><div class="ttdef"><b>Definition:</b> KeyboardEvent.hpp:30</div></div>
<div class="ttc" id="aclassgg_1_1KeyPressedEvent_html_a158a2d0cf96a6a404aaf7c8bec89acaa"><div class="ttname"><a href="classgg_1_1KeyPressedEvent.html#a158a2d0cf96a6a404aaf7c8bec89acaa">gg::KeyPressedEvent::KeyPressedEvent</a></div><div class="ttdeci">KeyPressedEvent(sf::Keyboard::Key)</div></div>
<div class="ttc" id="aclassgg_1_1KeyPressedEvent_html_a466c97780ec2cb0c9fbed923060e4ac2"><div class="ttname"><a href="classgg_1_1KeyPressedEvent.html#a466c97780ec2cb0c9fbed923060e4ac2">gg::KeyPressedEvent::~KeyPressedEvent</a></div><div class="ttdeci">~KeyPressedEvent() override=default</div></div>
<div class="ttc" id="aclassgg_1_1KeyPressedEvent_html_a59ebd4dc540d6cee0715652c0c09e868"><div class="ttname"><a href="classgg_1_1KeyPressedEvent.html#a59ebd4dc540d6cee0715652c0c09e868">gg::KeyPressedEvent::GetEventType</a></div><div class="ttdeci">auto GetEventType() const -&gt; EventType override</div></div>
<div class="ttc" id="aclassgg_1_1KeyReleasedEvent_html"><div class="ttname"><a href="classgg_1_1KeyReleasedEvent.html">gg::KeyReleasedEvent</a></div><div class="ttdef"><b>Definition:</b> KeyboardEvent.hpp:43</div></div>
<div class="ttc" id="aclassgg_1_1KeyReleasedEvent_html_a1f482b17b96ceb5141a4b4cfbbe4a154"><div class="ttname"><a href="classgg_1_1KeyReleasedEvent.html#a1f482b17b96ceb5141a4b4cfbbe4a154">gg::KeyReleasedEvent::KeyReleasedEvent</a></div><div class="ttdeci">KeyReleasedEvent(sf::Keyboard::Key keycode)</div></div>
<div class="ttc" id="aclassgg_1_1KeyReleasedEvent_html_a49587642a655c28b0c2d4042c0836e50"><div class="ttname"><a href="classgg_1_1KeyReleasedEvent.html#a49587642a655c28b0c2d4042c0836e50">gg::KeyReleasedEvent::GetEventType</a></div><div class="ttdeci">auto GetEventType() const -&gt; EventType override</div></div>
<div class="ttc" id="aclassgg_1_1KeyReleasedEvent_html_ad26aca2fd0b1a7ec81ffec12bd886479"><div class="ttname"><a href="classgg_1_1KeyReleasedEvent.html#ad26aca2fd0b1a7ec81ffec12bd886479">gg::KeyReleasedEvent::~KeyReleasedEvent</a></div><div class="ttdeci">~KeyReleasedEvent() override=default</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html">gg::KeyboardEvent</a></div><div class="ttdef"><b>Definition:</b> KeyboardEvent.hpp:11</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_a0a50fcf8c135a015551d375b4865f71c"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#a0a50fcf8c135a015551d375b4865f71c">gg::KeyboardEvent::KeycodeToString</a></div><div class="ttdeci">auto KeycodeToString() -&gt; char</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_a2dd18280ee3e99347875156d4aa8a600"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#a2dd18280ee3e99347875156d4aa8a600">gg::KeyboardEvent::KeyboardEvent</a></div><div class="ttdeci">KeyboardEvent()</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_a5963a3b82f5bd8c2fca8156297f15725"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#a5963a3b82f5bd8c2fca8156297f15725">gg::KeyboardEvent::mKeycodeString</a></div><div class="ttdeci">char mKeycodeString</div><div class="ttdef"><b>Definition:</b> KeyboardEvent.hpp:25</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_a81e1418e6e8554e9cedf580bd7b2b5ac"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#a81e1418e6e8554e9cedf580bd7b2b5ac">gg::KeyboardEvent::to_string</a></div><div class="ttdeci">virtual auto to_string() -&gt; std::string=0</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_a95443182d3146abfb2549ee1d9bdd72c"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#a95443182d3146abfb2549ee1d9bdd72c">gg::KeyboardEvent::GetEventType</a></div><div class="ttdeci">auto GetEventType() const -&gt; EventType override=0</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_abc64d61158c025aa2e940ddaecf04876"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#abc64d61158c025aa2e940ddaecf04876">gg::KeyboardEvent::GetKeycode</a></div><div class="ttdeci">auto GetKeycode() -&gt; sf::Keyboard::Key</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_acbc54be23fd27c01ab5f6ce6c558f85d"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#acbc54be23fd27c01ab5f6ce6c558f85d">gg::KeyboardEvent::~KeyboardEvent</a></div><div class="ttdeci">~KeyboardEvent() override=default</div></div>
<div class="ttc" id="aclassgg_1_1KeyboardEvent_html_ada0379b2c75fed648eada3923788b035"><div class="ttname"><a href="classgg_1_1KeyboardEvent.html#ada0379b2c75fed648eada3923788b035">gg::KeyboardEvent::mKeycode</a></div><div class="ttdeci">sf::Keyboard::Key mKeycode</div><div class="ttdef"><b>Definition:</b> KeyboardEvent.hpp:26</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_ada69b9f844678d00cd5c2b2c30a20122"><div class="ttname"><a href="namespacegg.html#ada69b9f844678d00cd5c2b2c30a20122">gg::EventType</a></div><div class="ttdeci">EventType</div><div class="ttdef"><b>Definition:</b> Event.hpp:11</div></div>
<div class="ttc" id="anamespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:84</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
